Redmine - Patch #39894

Explicitly render a 404 on non-JS requests to watchers#new
2023-12-20 18:02 - Holger Just

Status: Closed Start date:

Priority: Normal Due date:

Assignee: Marius BALTEANU % Done: 0%
Category: Code cleanup/refactoring Estimated time: 0.00 hour
Target version: 5.0.8

Description

The "Add watcher" button in the sidebar of issues is a javascript-ified link. Sometimes, crawlers hit this raw link and request non-JS
data.

This currently results in the rendering JS template. However, the response is eventually blocked by
ActionController::RequestForgeryProtection#verify_same_origin_request which is run as an after_action. This method then throws an
ActionController::InvalidCrossOriginRequest error and denies sending the rendered data to the client to avoid sending an
unauthorized cross-origin response.

This exception is then later handled by the ActionDispatch::ExceptionWrapper middleware which in turn send an empty 406
response.

The attached patch fixes this behavior by explicitly sending a 404 response when the (default) html format was requested for the
watchers#new action. This hopefully keeps strange crawlers from further crawling this link...

Related issues:
Related to Redmine - Patch #39999: Explicitly render a 404 on non-JS requests... Closed
Has duplicate Redmine - Defect #30489: Internal server error when click middl... Closed

Associated revisions

Revision 22538 - 2023-12-21 07:47 - Marius BALTEANU
Explicitly render a 404 on non-JS requests to watchers#new (#39894).

Patch by @hjust.

Revision 22539 - 2023-12-21 07:54 - Marius BALTEANU
Add test for #39894.

Revision 22540 - 2023-12-21 08:02 - Marius BALTEANU
Merge r22538 and r22539 from trunk to 5.1-stable (#39894).

Revision 22541 - 2023-12-21 08:02 - Marius BALTEANU
Merge r22538 and r22539 from trunk to 5.0-stable (#39894).

History

#1 - 2023-12-21 07:45 - Marius BALTEANU
- Assignee set to Marius BALTEANU

- Target version set to 5.0.8

Thanks Holger for reporting and fixing this issue. | think the same was reported in #30489.

I'm assigning this to 5.0.8.

#2 - 2023-12-21 07:45 - Marius BALTEANU

- Has duplicate Defect #30489: Internal server error when click middle mouse button link add watcher added

#3 - 2023-12-21 08:00 - Marius BALTEANU

- Category set to Code cleanup/refactoring
https://www.redmine.org/versions/192

- Status changed from New to Resolved
Committed with a test!

#4 - 2023-12-21 08:24 - Marius BALTEANU

- Status changed from Resolved to Closed

#5 - 2024-01-03 01:01 - Go MAEDA
- Related to Patch #39999: Explicitly render a 404 on non-JS requests to messages#quote added
